# Python
# Programming in context
# 07.10.18 - sv
# Exercice 2.5.9

# Aiguille de Buffon
# L'aiguille de Buffon est une expérience de probabilité proposée
# en 1733 par Georges-Louis Leclerc de Buffon,
# un scientifique français du xviiie siècle.
# Cette expérience fournit une approximation du nombre π.

import turtle, math, random

p = turtle.Turtle()
p.shape('classic')
p.speed('fast')

largeur = 50
grille = list(range(-450, 460, 50))

def parquet(tortue):
    """Dessine les traits verticaux"""
    tortue.color('brown')
    for k in range(20):
        tortue.up()
        tortue.goto(-450+largeur*k, -450)
        tortue.down()
        tortue.goto(-450+largeur*k, 450)

def ordonner(a, b):
    """classe a et b par ordre croissant"""
    if a>b:
        return (b, a)
    else:
        return (a, b)

#turtle.tracer(0, 0)
parquet(p)

z = turtle.Turtle()
z.shape('classic')
z.speed('fast')
z.up()

def lancer(tortue, coups):
    intersection = 0
    N = coups
    while coups > 0:
        x = -450 + 900.*random.random()
        y = -450 + 900.*random.random()
        angle = random.randint(-180, 180)
        tortue.setheading(angle)
        angle_rad = angle * (math.pi/180)
        x2 = x + largeur*math.cos(angle_rad)
        (a, b) = ordonner(x, x2)
        for el in grille:
            if el>=a and el<=b:
                intersection += 1
                tortue.color('red')
                break
        else:
            tortue.color('blue')
        tortue.up()
        tortue.goto(x, y)
        tortue.down()
        tortue.fd(largeur)
        coups -= 1
        z.goto(-520,0)
        z.clear()
        if intersection != 0:
            z.write(str(2*(N-coups)/intersection), font=("Arial", 12, "normal"))
    print(intersection)
    return 2*N/intersection
        
        
turtle.tracer(0, 0)
print("pi =", lancer(p, 200000))






